#include "Application.h"

#include <assert.h>

#include "Core/Logger.h"
#include "RHI/RHI.h"


    Application* s_Application = nullptr;

    Application::Application() {
        assert(nullptr == s_Application);
        s_Application = this;

        Logger::Init();
    }

    Application::~Application() {
        Logger::Shotdown();
        assert(nullptr != s_Application);
        s_Application = nullptr;
    }

    Application* Application::Get() {
        return s_Application;
    }

    bool Application::Initialize() {
        if (!RHI::Init()) {
            return false;
        }

        return true;
    }

    int Application::RunLoop() {
        const DriverSettings& setting = RHI::Get()->GetDriverSettings();
        if (nullptr == setting.isWindowShouldClose) {
            return -1;
        }

        RHI::Get()->StartRenderThread();

        while (!setting.isWindowShouldClose()) {
            RHI::Get()->PollEvents();
        }
        return 0;
    }

    void Application::Uninitialize() {
        RHI::Shotdown();
    }